###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

$openfolder = "<img src=\"$imagesdir/open.gif\" border=0>";
$coll = "4";
$colxl = "5";
if ($enable_modshow eq "1") {
&modshow;
}

sub BoardIndex {
        # Open the file with all categories
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        $title = "$BoardIndex{'1'}";
        open(FILE, "$memberdir/memberlist.txt");
        &lock(FILE);
        @memberlist = <FILE>;
        &unlock(FILE);
        $memcount = @memberlist;
        close(FILE);
        # First we're going to count how many threads and messages are posted
        $totalm=0;
        $totalt=0;
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                open(CAT, "$boardsdir/$curcat.cat");
                &lock(CAT);
                @catinfo = <CAT>;
                &unlock(CAT);
                close(CAT);
                $catinfo[1] =~ s/[\n\r]//g;
                foreach(split(/\,/,$catinfo[1])) {
                        $membergroups{$_} = $_;
                }
                if($catinfo[1] ne "") {
                        if($settings[7] ne "Administrator" && !exists $membergroups{$settings[7]}) {
                                next;
                        }
                }
                $curcatname="$catinfo[0]";
                foreach $curboard (@catinfo) {
                        if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
                                $curboard =~ s/[\n\r]//g;
                                open(BOARDDATA, "$boardsdir/$curboard.txt");
                                &lock(BOARDDATA);
                                @messages = <BOARDDATA>;
                                &unlock(BOARDDATA);
                                close(BOARDDATA);
                                $tm = @messages;
                                ($dummy, $dummy, $dummy, $dummy, $lp) = split(/\|/, $messages[0]);
                                $boardinfo[2] =~ s/\n//g;
                                $boardinfo[2] =~ s/\r//g;
                                $messagecount=0;
                                for ($a = 0; $a < @messages; $a++) {
                                        ($dm,$dm,$dm,$dm,$dm,$mreplies,$dm) = split(/\|/,$messages[$a]);
                                        $messagecount++;
                                        $messagecount=$messagecount+$mreplies;
                                }
                                if($lp eq "") { $lp="-"; }
                                $totalm=$totalm+$messagecount;
                                $totalt=$totalt+$tm;
                        }
                }
        }
# Now we're printing the categories and boards
        open (FILE, "$vardir/newuser.txt");
        &lock(FILE);
        $lastuser = <FILE>;
        &unlock(FILE);
        close(FILE);
        ($lu_realname, $lu_username) = split(/\|/, $lastuser);
        &header;
        &menu2;
        
print "<table width=100% cellpadding=4>\n";
print "<tr>\n";
if ($enable_stat eq "1") {
        if ($locate_stat eq "0") {
                &stat;
                print "$statoben1\n";
        }
else {
&stat;
print "$statoben2\n";
}
}else {
&stat;
print "$statoben2\n";
}

print <<"EOT";
</td>
</tr>
</table>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
$newsontop
EOT
if($enable_news) {
   if($newsart == "2") {
print <<"EOT";
<tr>
        <td bgcolor="$color{'windowbg2'}" valign=top colspan=$colxl height=45>
        <SCRIPT LANGUAGE="JavaScript1.2" TYPE="text/javascript">
        <!--
        NS4 = (document.layers);
        IE4 = (document.all);
           FDRboxWid = 650;
           FDRboxHgt = 45;
           FDRborWid = 4;
           FDRborCol = "$color{'windowbg2'}";
           FDRborSty = "solid";
           FDRbackCol = "$color{'windowbg2'}";
           FDRboxPad = 4;

           FDRtxtAln = "center";
           FDRlinHgt = "11pt";
           FDRfntFam = "Verdana";
           FDRfntCol = "$color{'fadertext2'}";
           FDRfntSiz = "10pt";
           FDRfntWgh = "bold";
           FDRfntSty = "normal";
           FDRlnkCol = "#000080";
           FDRlnkDec = "underline";
           FDRhovCol = "#800000";

           FDRgifSrc = "$imagesdir/fade.gif";
           FDRgifInt = 60;

           FDRblendInt = 5;
           FDRblendDur = 1;
           FDRmaxLoops = 100;

           FDRendWithFirst = true;
           FDRreplayOnClick = true;

           FDRjustFlip = false;
           FDRhdlineCount = 0;
        //-->
        </SCRIPT>

        <SCRIPT LANGUAGE='JavaScript1.2' TYPE='text/javascript'>
        prefix="";
        arNews = [
        "<font color=\\"$color{'fadertext'}\\" face=\\"$FontFace\\">$BoardIndex{'6'}</font>","",
EOT
        for($i=0;$i<@newsmessages;$i++) {
        $newsmessages[$i] =~ s/\n//g;
        $newsmessages[$i] =~ s/\r//g;
        $newsmessages[$i] =~ s/\"/\\\"/g;
        if($i != 0)
                {print ",\n";}
        print "\"$newsmessages[$i]\",";
        print "\"\"";
        }
print <<"EOT";
        ]
	</SCRIPT>
	  <div align="center">
	<SCRIPT LANGUAGE='JavaScript1.2' SRC='$imagesdir/fader.js' TYPE='text/javascript'></SCRIPT>
		<div id="elFader" style="position:relative;visibility:hidden;width:650;">
		<font face="Verdana, Arial" size=2>News Fader for DHTML Browser.</font>
		</div>
	  </div>
        </td>
</tr>
EOT
      }
}
print <<"EOT";
<tr>
        <td bgcolor="$color{'titlebg'}" width=10><font size=$Fontsize face="$FontFace">&nbsp;</font></td>
        <td bgcolor="$color{'titlebg'}"><font color="$color{'titletext'}" size=$Fontsize face="$FontFace"><b>$BoardIndex{'2'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" nowrap align=center><font color="$color{'titletext'}" size=$Fontsize face="$FontFace"><b>$BoardIndex{'3'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" nowrap align=center><font color="$color{'titletext'}" size=$Fontsize face="$FontFace"><b>$BoardIndex{'4'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" nowrap align=center><font color="$color{'titletext'}" size=$Fontsize face="$FontFace"><b>$BoardIndex{'5'}</b></font></td>
EOT
if ($enable_modshow eq "1") {
print "$tb1\n";
}
print "</tr>\n";
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                open(CAT, "$boardsdir/$curcat.cat");
                &lock(CAT);
                @catinfo = <CAT>;
                &unlock(CAT);
                close(CAT);
                $catinfo[1] =~ s/[\n\r]//g;

                foreach(split(/\,/,$catinfo[1])) {
                        $membergroups{$_} = $_;
                }

                if($catinfo[1] ne "") {
                        if($settings[7] ne "$Administrator" && !exists $membergroups{$settings[7]} || $settings[7] ne "$Administrator" && !exists $membergroups{$settings[7]} ) {
                                next;
                        }
                }
                $curcatname="$catinfo[0]";
                print <<"EOT";
<tr>
        <td bgcolor="$color{'catbg'}" width=10 valign=top><img src="$imagesdir/cat.gif"  alt="" border="0"></td>
        <td colspan=$coll  bgcolor="$color{'catbg'}"><font size=$Fontsize face="$FontFace"><b>$curcatname</b></font></td>
</tr>
EOT
                foreach $curboard (@catinfo) {
                        # Open the categegory file and list all boards in it
                        if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
                                $curboard =~ s/[\n\r]//g;
                                open(BOARD, "$boardsdir/$curboard.dat");
                                &lock(BOARD);
                                @boardinfo = <BOARD>;
                                &unlock(BOARD);
                                close(BOARD);
                                $curboardname="$boardinfo[0]";
                                $descr="$boardinfo[1]";
                                open(BOARDDATA, "$boardsdir/$curboard.txt");
                                &lock(BOARDDATA);
                                @messages = <BOARDDATA>;
                                &unlock(BOARDDATA);
                                close(BOARDDATA);
                                $tm = @messages;
                                if(@messages == 0) { $tm="<font size=$Fontsize1 face=\"$FontFace\">-</font>"; }
                                ($dummy, $dummy, $dummy, $dummy, $lp) = split(/\|/, $messages[0]);
                                $boardinfo[2] =~ s/[\n\r]//g;
                                $messagecount=0;
                                for ($a = 0; $a < @messages; $a++) {
                                        ($dm,$dm,$dm,$dm,$dm,$mreplies,$dm) = split(/\|/,$messages[$a]);
                                        $messagecount++;
                                        $messagecount=$messagecount+$mreplies;
                                }
#######################################
if ($enable_modshow eq "1") {

                                %moderators = ();

                                foreach(split(/\|/,$boardinfo[2])) {

                                        open(MODERATOR, "$memberdir/$_.dat");
                                        &lock(MODERATOR);
                                        @modprop = <MODERATOR>;
                                        &unlock(MODERATOR);
                                        close(MODERATOR);
                                        $modprop[1] =~ s/[\n\r]//g;

                                        $moderators{$_} = $_;
#                                        $moderators{$_} = $modprop[1];
                                }

                                $showmods = "";

                                foreach $muname (keys %moderators) {
                                        $showmods .= "<a href=\"$boardurl/YaBB.pl?board=&action=viewprofile&username=$muname\">$moderators{$muname}</a>, ";
                                }

                                $showmods =~ s/, $//;
}
#######################################

                                if($lp eq "") { $lp="-"; }
                                $dlp = &readlog("$curboard");
                                $new="";
                                if($dlp ne "$lp" && $lp ne "-" && $username ne "Guest") {
                                        $new = "<img src=\"$imagesdir/new.gif\">";
                                }
        # open up the last poster
        open(POSTER, "$boardsdir/$curboard.poster");
        &lock(POSTER);
        $lastpost = <POSTER>;
        ($lastposter, $lpurl) = split(/\|/,$lastpost);
        &unlock(POSTER);
        close(POSTER);

        if ($lastposter eq "")
        {
                $lastposter = "-";
                $lpurl="";
        }
        else
        {
                if ($lpurl ne "")
                {
#                if ($lpurl ne "Guest") {
                $lastposter = "$BoardIndex{'21'} <a href=\"$boardurl/YaBB.pl?board=test1&action=viewprofile&username=$lpurl\">$lastposter</a>";
                #}
                #else {
                #$lastposter = "$lastposter";
#                }
                }
        }

                                print <<"EOT";
<tr>
        <td bgcolor="$color{'windowbg'}" width=10 valign=top><img src="$imagesdir/board.gif"  border="0"></td>
        <td bgcolor="$color{'windowbg'}" width=* valign=top><font size=$Fontsize face="$FontFace"><b><a href="YaBB.pl?board=$curboard">$curboardname</a>$new</b><br>
        $descr</font></td>
        <td bgcolor="$color{'windowbg'}" valign=top width=13% align=center><font size=$Fontsize face="$FontFace">$tm</font></td>
        <td bgcolor="$color{'windowbg'}" valign=top width=13% align=center><font size=$Fontsize face="$FontFace">$messagecount</font></td>
        <td bgcolor="$color{'windowbg'}" valign=top width=20% align=center><font size=$Fontsize1 face="$FontFace">$lp<br>$BoardIndex{'218'} $lastposter</font></td>
EOT
if ($enable_modshow eq "1") {
&modshow;
print "$tb2\n";
}
print "</tr>\n";
                        }
                }
        }


         $guests=0;
        $users="";
        open(LOG, "$vardir/log.txt");
        &lock(LOG);
        @entries = <LOG>;
        &unlock(LOG);
        close(LOG);
        foreach $curentry (@entries) {
                $curentry =~ s/[\n\r]//g;
                ($name, $value) = split(/\|/, $curentry);
                if($name =~ /\./) { ++$guests }
                else {
                        $users = "$users <a href=\"$cgi\&action=viewprofile\&username=$name\">$name</a>\n"; }
        }

	if( $username ne 'Guest' ) {
		print <<"EOT";
<!--<tr>
	<td class="title1" bgcolor="$color{'titlebg'}" colspan=6 align="center">
	<a href="YaBB.pl?action=markallasread"><img src="$imagesdir/markread.gif" alt="$txt{'452'}" border=0></a></td>
</tr>-->
EOT
}

$allusers = @entries;
if($username ne "Guest") {
                open(IM, "$memberdir/$username.msg");
                &lock(IM);
                @immessages = <IM>;
                &unlock(IM);
                close(IM);
                $mnum = @immessages;
                $messnum = "$mnum";
}
if($mnum eq "1") {
                $s = ""
}
        else {
                $s ="s"
}
if($guests == "1") {
                $gasrname="$BoardIndex{'8'}";
}
        else {
                $gasrname="$BoardIndex{'9'}";
}
        print <<"EOT";

</table>
<br>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
EOT
        if($username ne "Guest") {
        print <<"EOT";
<tr>
        <td colspan=$colxl bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$BoardIndex{'10'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/online.gif" alt="online" border="0"></td>
        <td bgcolor="$color{'windowbg2'}" valign=top colspan=$coll><font size=$Fontsize face="$FontFace"><b><A href="YaBB.pl?action=mltop">$BoardIndex{'11'}</A></b></font><br><font size=$Fontsize1 face="$FontFace">$BoardIndex{'12'}</font>
</td>
</tr>
EOT
}

if ($enable_stat eq "1") {
        if ($locate_stat eq "1") {
                &stat;
                print "$statunten";
        }
}
print <<"EOT";
<tr>
        <td colspan=$colxl bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$BoardIndex{'13'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/online1.gif" alt="online" border="0"></td>
        <td bgcolor="$color{'windowbg2'}" valign=top colspan=$coll><font size=$Fontsize face="$FontFace"><b><a href="$cgi&action=who">$BoardIndex{'14'}</a></b> ($allusers)</font><br><font size=$Fontsize1 face="$FontFace">$users $BoardIndex{'15'} $guests $gasrname</font></td>
</tr>
EOT
        if($username ne "Guest") {
                print <<"EOT";
<tr>
        <td colspan=$colxl bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$BoardIndex{'16'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/pmon.gif" alt="" border="0"></td>
        <td bgcolor="$color{'windowbg2'}" valign=top colspan=$coll><font size=$Fontsize face="$FontFace"><b><a href=\"$cgi\&action=im\">$BoardIndex{'17'}</a></b></font><br><font size=$Fontsize1 face="$FontFace">$BoardIndex{'18'} $mnum $BoardIndex{'17'}</font>
</td>
</tr>
EOT

if ($enable_chat eq "1") {
&chat
}
        if ($enable_textmark eq "1") {
        &textmark
        }
}
print <<"EOT";
<tr>
        <td colspan=$colxl bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$BoardIndex{'19'} $maxmonitor $BoardIndex{'20'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/online.gif" alt="online" border="0"></td>
        <td bgcolor="$color{'windowbg2'}" valign=top colspan=$coll><font size=$Fontsize face="$FontFace">
EOT


        $post = "";
        open(LASTPOST, "$vardir/recentpost.txt");
        @recentpost = <LASTPOST>;
        close(LASTPOST);
        foreach $line(@recentpost) {
                @post = split(/\|/,$line);
                $post[4] =~ s/[\n\r]//g;
                if ($post[0] ne "")
                {
                        print "[<a href=\"$cgi$post[1]\">$post[4]</a>] <a href=\"$cgi$post[1]&action=display&num=$post[0]\">$post[3]</a> <i>$BoardIndex{'21'} $post[2]</i><br>";
                }
                else
                {
                        print "[<a href=\"$cgi$post[1]\">$post[4]] $post[3] <i>$BoardIndex{'21'} $post[2]</i><br>";
                }
        }

print <<"EOT";
</font></td></tr>
</table>
EOT
        &footer;
        exit;
}

1;