###############################################################################
# Display.pl                                                                  #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

$openfolder = "<img src=\"$imagesdir/openfolder.gif\" border=0>";
$closedfolder = "<img src=\"$imagesdir/closedfolder.gif\" border=0>";

&guest_login;
sub Display {
&DPPrivate;
&DCPrivate;
        $viewnum = $INFO{'num'};
        if ($viewnum !~ /^[0-9]/){ &fatal_error("$Display{'1'}"); }
        if ($viewnum !~ /^[0-9]+$/){ &fatal_error("$Display{'1'}" ); }
        open(FILE, "$datadir/$viewnum.txt") || &fatal_error("$Display{'2'} $viewnum.txt");
        &lock(FILE);
        @messages = <FILE>;
        &unlock(FILE);
        close(FILE);
        ($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[@messages-1]);
        $writedate = "$mdate";
        &writelog("$viewnum");
                $filetoopen = "$viewnum" . ".data";
                open(FILE2, "$datadir/$filetoopen");
                &lock(FILE2);
                $tempinfo = <FILE2>;
                &unlock(FILE2);
                close(FILE2);

                ($views, $lastposter, $viewip, $viewip2) = split(/\|/,$tempinfo);
if ($viewip ne "$ENV{'REMOTE_ADDR'}") {
        if ($viewip2 ne "$ENV{'REMOTE_ADDR'}") {
                $views++;

                $filetoopen = "$viewnum" . ".data";
                open(FILE2, "+>$datadir/$filetoopen");
                &lock(FILE2);
                print FILE2 "$views|$lastposter|$ENV{'REMOTE_ADDR'}|$viewip";
                &unlock(FILE2);
                close(FILE2);
        }
}

#############
        open(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$Display{'2'} $currentboard.txt");
        &lock(FILE);
        @threads = <FILE>;
        &unlock(FILE);
        close(FILE);
        $noposting=0;
        for ($x = 0; $x < @threads; $x++) {
($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$threads[$x]);
                if ($viewnum eq $mnum && $mstate==1) {
                        $noposting=1;
                }
                if($viewnum eq $mnum) { $x = @threads; }
        }
        if($mstate==0) { $type="thread"; }
        if($mreplies>=$hot1) { $type="hotthread"; }
        if($mreplies>=$hot2) { $type="veryhotthread"; }
        if($mstate==1) { $type="locked"; }
        #############
        ($msub[0], $mname[0], $memail[0], $mdate[0], $musername[0], $micon[0], $mattach[0], $mip[0], $mmessage[0], $mns[0]) = split(/\|/,$messages[0]);
        ##################
        $title="$msub[0]";
        &header;
	&menu2;
        open(CENSOR, "$vardir/censor.txt");
        &lock(CENSOR);
        @censored = <CENSOR>;
        &unlock(CENSOR);
        close(CENSOR);
        foreach $censor (@censored) {
                $censor =~ s/[\n\r]//g;
                ($word, $censored) = split(/\=/, $censor);
                $msub[0] =~ s/$word/$censored/gi;
        }
        ##################
        if($enable_notification) {
                $notification = <<"EOT";
<a href="$cgi&action=notify&thread=$viewnum"><img src="$imagesdir/notify.gif" alt="$Display{'3'}" border="0"></a>
EOT
        }
        &jumpto;
        if($INFO{'start'} ne "") { $start="$INFO{'start'}"; } else { $start=0; }
        if (@moderators==1) {
                $showmods = "($Display{'4'}: ";
        } else {
                $showmods = "($Display{'5'}: ";
        }

        foreach $muname (keys %moderators) {
                $showmods .= "<a href=\"$boardurl/YaBB.pl?board=&action=viewprofile&username=$muname\">$moderators{$muname}</a>, ";
        }

        $showmods =~ s/, $//;
        $showmods .= ")";
        print <<"EOT";
<table width=100% align=center>
<tr>
EOT
if ($nav_art eq "1") {
print <<"EOT";
<td valign=bottom><font face="$FontFace" size="$Fontsize">$closedfolder &nbsp\;<a href="$boardurl/YaBB.pl">$mbname</a>
$closedfolder &nbsp\;<a href="$cgi">$boardname</a>&nbsp\; $openfolder &nbsp\; $msub[0]  $showmods</font></td>
EOT
} else {
print <<"EOT";
<td valign=bottom>
<FONT SIZE="1" FACE="Verdana, Arial">
<IMG SRC="$imagesdir/folder-1p.gif" WIDTH=18 HEIGHT=20 ALIGN=middle BORDER=0>&nbsp;&nbsp;<A href="$boardurl/YaBB.pl">$mbname</A><br>
<IMG SRC="$imagesdir/folder-2p.gif" WIDTH=38 HEIGHT=20 ALIGN=middle BORDER=0>&nbsp;&nbsp;<a href="$cgi">$boardname</A> $showmods<br>
<IMG SRC="$imagesdir/folder-3.gif" WIDTH=58 HEIGHT=20 ALIGN=middle BORDER=0>&nbsp;&nbsp;$msub[0]
</td>
EOT
}
print <<"EOT";
<td align=right><font size="$Fontsize" face="$FontFace"><a href="$cgi&action=rewritten&board=$currentboard&num=$viewnum&title=$msub[$b]" target="_blank"><img src="$imagesdir/print.gif" alt="$Display{'6'}" border=0></a><br><a href="$cgi&action=post&num=$viewnum&title=$Display{'7'}&start=$start"><img src="$imagesdir/reply.gif" alt="$Display{'8'}" border="0"></a>$notification</font></td>
</tr>
</table>

<table border=0 width=100% bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}" nowrap><font size="$Fontsize" color="$color{'titletext'}" face="$FontFace"><img src="$imagesdir/$type.gif"><font size="$Fontsize" face="$FontFace" color="$color{'titletext'}">&nbsp;<b>$Display{'9'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" nowrap colspan="2"><font size="$Fontsize" color="$color{'titletext'}" face="$FontFace"><b>$Display{'10'}: $msub[0]</b></font></td>
</tr>
EOT
        for ($a = $start; $a < @messages; $a++) {
                ++$numshown;
                if($second eq "$color{'windowbg'}") { $second="$color{'windowbg2'}"; }
                else { $second="$color{'windowbg'}"; }
                ($msub[$a], $mname[$a], $memail[$a], $mdate[$a], $musername[$a], $micon[$a], $mattach[$a], $mip[$a],  $mmessage[$a], $mns[$a]) = split(/\|/,$messages[$a]);

                $subject = "$msub[$a]";
                if($subject eq "") { $subject="$Display{'11'}"; }
                $mmessage[$a] =~ s/\n//g;
                $message="$mmessage[$a]";
                $ns="$mns[$a]";
                                if ($musername[$a] ne "Guest") {
                   $name = "$musername[$a]";
                                } else {
                   $name = "$mname[$a]";
                                }
                $date = "$mdate[$a]";

                if($settings[7] eq "$Administrator") { $ip = "<b>IP:</b> $mip[$a]"; }
                else { $ip = ""; }

                open(FILE, "$memberdir/$musername[$a].dat");
                &lock(FILE);
                @memset = <FILE>;
		&unlock(FILE);
                close(FILE);

                $removed=0;
                if(!(-e("$memberdir/$musername[$a].dat"))) { $removed=1; }
                $postinfo="";
                $signature="";
                $viewd="";
                $icq="";
                $star="";
                $sendm="";
                $usertext="";
                                $icqad="";
                                $GenderImage="";
                                $land="";
                                $memberpic="";
                                $aim = "";
                                $aimaddme = "";
                                $yim = "";

                if($musername[$a] ne "Guest" && $removed==0) {
                        if($username ne "Guest") {
                                $sendm = " <a href=\"$cgi\&action=imsend\&to=$musername[$a]\"><img src=\"$imagesdir/message.gif\" alt=\"$Display{'13'}\" border=0></a>";
                        }
                        open(FILE, "$memberdir/$musername[$a].dat");
                        &lock(FILE);
                        @memset = <FILE>;
                        &unlock(FILE);
                        close(FILE);
                        $postinfo = "$Display{'14'}: $memset[6]<br>";
                        $viewd = " <a href=\"$cgi\&action=viewprofile\&username=$musername[$a]\"><img src=\"$imagesdir/profile.gif\" alt=\"$Display{'15'}\" border=0></a>";
                                                require "$sourcedir/Membergroups.pl";
                                                &memberstatus;
                        $signature = "$memset[5]";
                        $signature =~ s/\&\&/<br>/g;
                        if($memset[5] eq "\n"){
                                $signature= "";
                       } else {
                                $signature= "$signature";
                        }
                        $memset[8] =~ s/[\n\r]//g;
                        if(!($memset[8] =~ /\D/) && $memset[8] ne "") {
                                $icq="<a href=\"javascript:openScript('$cgi\&action=icqpager&UIN=$memset[8]',450,300)\"><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a> &nbsp; ";
                                $icqad = "<a href=\"http://wwp.icq.com/scripts/search.dll?to=$memset[8]\" target=_blank><img src=\"$imagesdir/add.gif\" alt=\"$memset[8]\" border=0></a>  &nbsp; ";
                        }
                                                if ($enable_aim eq "1") {
                        $memset[9] =~ s/[\n\r]//g;
                        if($memset[9] ne "") {
                                $aim = "<a href=\"aim:goim?screenname=$memset[9]&message=Hi.+Are+you+there?\"><img SRC=\"$imagesdir/aim.gif\" alt=\"$memset[9]\" border=\"0\"></a> &nbsp; ";
                                $aimaddme = "<a href=\"aim:addbuddy?screenname=$memset[9]\"><img SRC=\"$imagesdir/aimaddme.gif\" alt=\"$memset[9]\" border=\"0\"></a> &nbsp; ";
                        }
                                                }
                                                if ($enable_yim eq "1") {
                        $memset[10] =~ s/[\n\r]//g;
                        if($memset[10] ne "") {
                                $yim = "<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=$memset[10]\" target=\"_blank\"><img SRC=\"$imagesdir/yim.gif\" alt=\"$memset[10]\" border=\"0\"></a> &nbsp; ";
                        }
                                                }
                                                if ($enable_gender eq "1") {
                        $memset[11] =~ s/[\n\r]//g;
                        if($memset[11] eq "mnnlich") {
                                $GenderImage = "$Display{'16'}:<img src=\"$imagesdir/male.gif\" BORDER=0><br>";
                        }elsif ($memset[11] eq "weiblich") {
                                $GenderImage = "$Display{'16'}:<img src=\"$imagesdir/female.gif\" BORDER=0><br>";
                        }else{
                                $GenderImage = "";
                        }
                                                }
                                                if ($enable_usertext eq "1") {
                        $memset[12] =~ s/[\n\r]//g;
                        if($memset[12] ne "") {
                                $usertext = "$memset[12]<br>";
                        }
                                                }
                                                if ($enable_wohnort eq "1") {
                                                $memset[13] =~ s/[\n\r]//g;
                        if($memset[13] ne "") {
                                $land = "aus: $memset[13]";
                        }
                                                }
                                                if ($enable_memberpic eq "1") {
                                        $memset[14] ||= '$imagesdir/faces/blank.gif';
                                        $memset[14] = $memset[14] =~ m~\Ahttp://~ ? qq~<br><img src="$memset[14]" width = "$mempicwidth" height= "$mempicheight" border="0"><br><br>~ : qq~<br><img src="$imagesdir/faces/$memset[14]" width = "$mempicwidth" height= "$mempicheight" border="0"><br><br>~;
                                        $memberpic = "$memset[14]";
                                }
                                else{
                                $memberpic = "";
                                }
                        } else { $memberinfo = "$Display{'17'}"; }
                        $message = "$message\n[line]$signature";
                        if($enable_ubbc) {
                        &DoUBBC;
                        }
                if ($showemail == "$memset[15]") {
		$mailzeigen = "<img src=\"$imagesdir/email.gif\" alt=\"E-Mail\" border=0>";
		}  else        {
		$mailzeigen = "<a href=\"mailto:$memset[2]\"><img src=\"$imagesdir/email.gif\" alt=\"E-Mail\" border=0></a>";
		}
                        $url="";
                        if($memset[3] ne "\n" && $musername[$a] ne "Guest") {
                                $url= " <a href=\"$memset[4]\" target=\"_blank\"><img src=\"$imagesdir/www.gif\" alt=\"$Display{'18'}\" border=0></a>";
                        }
                ##################
                foreach $censor (@censored) {
                        $censor =~ s/[\n\r]//g;
                        ($word, $censored) = split(/\=/, $censor);
                        $message =~ s/$word/$censored/gi;
                        $subject =~ s/$word/$censored/gi;
                }
                ##################
                if ($settings[7] ne "$Administrator") {
                        $ip = "";
                }
                print <<"EOT";
<tr>
    <td bgcolor="$second" width="140" valign="top" rowspan="3"><font size="$Fontsize" face="$FontFace"><b>$name</b></font><br>
      <font size="$Fontsize1" face="$FontFace">$memberinfo<br>
      $star<br>
      $land<br>
      $memberpic
      $usertext
      $postinfo<br>
      $GenderImage
      $icq
      $icqad
      $aim
      $aimaddme
      $yim
      </font></td>
      <td bgcolor="$second" colspan="2">
      <table width="100%"><tr>
          <td bgcolor="$second">
          <img src="$imagesdir/$micon[$a].gif" width="16" height="16">
          <font size="$Fontsize1" face="$FontFace">&nbsp;&nbsp;<b>$subject</b></font>
          </td>
          <td bgcolor="$second" align="right"><font size="$Fontsize1" face="$FontFace"><b>$Display{'29'}:</b>$date $ip</font></td>
      </tr></table>
  </tr>
  <tr>
    <td bgcolor="$second" valign="top" colspan="2"><font size="$Fontsize" face="$FontFace"><br><br>$message<br><br></font></td>
  </tr>
  <tr>
        <td bgcolor="$second"><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=1>
$url $mailzeigen $viewd$sendm</font></td>

<td align="right" bgcolor="$second" nowrap>
EOT
if($username eq "Guest") {
print <<"EOT";
<font size=$Fontsize1 face="$FontFace"><a href="$cgi&action=copy&num=$viewnum&copy1=$a&title=$Display{'20'}&start=$start"><img src="$imagesdir/copy.gif" alt="$Display{'251'}" border=0></a> <a href="$cgi&action=post&num=$viewnum&quote=$a&title=$Display{'20'}&start=$start"><img src="$imagesdir/quote.gif" alt="$Display{'252'}" border=0></a></font></td></tr></table>
EOT
} else {
print <<"EOT";
<font size=$Fontsize1 face="$FontFace"><a href="$cgi&action=copy&num=$viewnum&copy1=$a&title=$Display{'20'}&start=$start"><img src="$imagesdir/copy.gif" alt="$Display{'251'}" border=0></a> <a href="$cgi&action=post&num=$viewnum&quote=$a&title=$Display{'20'}&start=$start"><img src="$imagesdir/quote.gif" alt="$Display{'252'}" border=0></a> <a href="$cgi&action=modify&message=$a&thread=$viewnum"><img src="$imagesdir/modify.gif" alt="$Display{'253'}" border=0></a> <a href="$cgi&action=modify2&thread=$viewnum&id=$a&d=1"><img src="$imagesdir/delete.gif" alt="$Display{'254'}" border=0></a></font></td></tr></table>
EOT
        }
print <<"EOT";
</tr>
EOT
;
                if ($numshown >= $maxmessagedisplay) { $a = @messages; }
        }
print <<"EOT";
</table>


<table border=0 width=100% cellspacing=0 cellpadding=0>
<tr>
        <td><font size="$Fontsize" face="$FontFace"><b>$Display{'21'}:</b>
EOT
$nummessages=@messages;
$c=0;
while(($c*$maxmessagedisplay)<$nummessages) {
        $viewc = $c+1;
        $strt = ($c*$maxmessagedisplay);
        if($start == $strt) {
                print <<"EOT";
$viewc
EOT
        } else {
                print <<"EOT";
<a href="$cgi&action=display&num=$viewnum&start=$strt">$viewc</a>
EOT
        }
        ++$c;
}
print <<"EOT";
</font></td><td align=center><font size="$Fontsize" face="$FontFace">
EOT

if($moderators{$username} ne "" || $settings[7] eq "Administrator") { $adminfunction = "<b>$Display{'22'}:</b>
<a href=\"$cgi\&action=movethread\&thread=$viewnum\">$Display{'23'}</a>
<a href=\"$cgi\&action=removethread\&thread=$viewnum\">$Display{'24'}</a>
<a href=\"$cgi\&action=lock\&thread=$viewnum\">$Display{'25'}</a>"; }

print <<"EOT";
$adminfunction
</font>

</td>
        <td align=right><font size="$Fontsize" face="$FontFace"><a href="$cgi&action=post&num=$viewnum&title=$Display{'20'}&start=$start"><img src="$imagesdir/reply.gif" alt="$Display{'26'}" border="0"></a>$notification</font></td>
</tr>
</table>
<div align=right><form action="YaBB.pl" method="GET">
<font size=$Fontsize1 face="$FontFace">$Display{'27'}: <select name="board">$selecthtml</select> <input type=submit value="$Display{'28'}"></form></div>
EOT
        &footer;
        exit;
}

sub DoUBBC {
        ###### Uniform Bulletin Board Code (UBBC) ########
        $message =~ s|<br>| [br]|g;
        $message =~ s|<|&lt;|g;
        $message =~ s|>|&gt;|g;
        if($ns =~ "NS") {
        }
        else {
                $message =~ s/\:\)/\<img src=$imagesdir\/smiley\.gif\>/g;
                $message =~ s/\:\-\)/\<img src=$imagesdir\/smiley\.gif\>/g;
                $message =~ s/(\W)\;\)/$1\<img src=$imagesdir\/wink.gif\>/g;
                $message =~ s/(\W)\;\-\)/$1\<img src=$imagesdir\/wink.gif\>/g;
                $message =~ s/\:D/\<img src=$imagesdir\/cheesy.gif\>/g;
                $message =~ s/(\W)\;D/$1\<img src=$imagesdir\/grin.gif\>/g;
                $message =~ s/\)\:\(/\<img src=$imagesdir\/angry.gif\>/g;
                $message =~ s/\>\:\(/\<img src=$imagesdir\/angry.gif\>/g;
                $message =~ s/\:\-\(/\<img src=$imagesdir\/sad.gif\>/g;
                $message =~ s/\:\(/\<img src=$imagesdir\/sad.gif\>/g;
                $message =~ s/\:o/\<img src=$imagesdir\/shocked.gif\>/gi;
                $message =~ s/8\)/\<img src=$imagesdir\/cool.gif\>/g;
                $message =~ s/\?\?\?/\<img src=$imagesdir\/huh.gif\>/g;
                $message =~ s/\?\!\?/\<img src=$imagesdir\/huh.gif\>/g;
        }

        $message =~ s|\[\[|\{\{|g;
        $message =~ s|\]\]|\}\}|g;
        $message =~ s|\n\[|\[|g;
        $message =~ s|\]\n|\]|g;
        $message =~ s/\|/\&#124;/g;
        $message =~ s|\[hr\]\n|\<hr width=40\% align=left>|g;
        $message =~ s|\[hr\]|\<hr width=40\% align=left>|g;
        $message =~ s|\[line\]|\<hr width=100%\% align=left color=\"ffffff\">|g;

        $message =~ s/\[br\]/\<br>/isg;

        $message =~ s/\[url\](\S+?)\[\/url\]/<a href=\"$1\"\ target=\"_blank\">$1<\/a>/isg;

        $message =~ s/\[url=http:\/\/(\S+?)\]/<a href=\"http:\/\/$1\"\ target=\"_blank\">/isg;
        $message =~ s/\[url=ftp:\/\/(\S+?)\]/<a href=\"ftp:\/\/$1\"\ target=\"_blank\">/isg;
        $message =~ s/\[url=news:\/\/(\S+?)\]/<a href=\"news:\/\/$1\"\ target=\"_blank\">/isg;
        $message =~ s/\[url=gopher:\/\/(\S+?)\]/<a href=\"gopher:\/\/$1\"\ target=\"_blank\">/isg;
        $message =~ s/\[url=(\S+?)\]/<a href=\"http:\/\/$1\"\ target=\"_blank\">/isg;
        $message =~ s/\[\/url\]/<\/a>/isg;

        $message =~ s/\[b\]/<b>/isg;
        $message =~ s/\[\/b\]/<\/b>/isg;

        $message =~ s/\[s\]/<s>/isg;
        $message =~ s/\[\/s\]/<\/s>/isg;

        $message =~ s/\[i\]/<i>/isg;
        $message =~ s/\[\/i\]/<\/i>/isg;

        $message =~ s/\[u\]/<u>/isg;
        $message =~ s/\[\/u\]/<\/u>/isg;

        $message =~ s/\[url\](.+?)\[\/url\]/<a href=\"$1\">$1<\/a>/isg;
        $message =~ s/\[img\](.+?)\[\/img\]/<img src=\"$1\">/isg;

        $message =~ s/\[color=(\S+?)\]/<font color=\"$1\">/isg;
        $message =~ s/\[\/color\]/<\/font>/isg;


        $message =~ s/\[quote\]/<div align=\"center\">
  <center>
  <table border=\"1\" bordercolor=\"$color{'frame2'}\" width=\"90%\" cellspacing=\"0\" cellpadding=\"0\">
    <tr>
      <td width=\"100%\" bgcolor=\"$color{'frame2'}\"><font size=\"1\" face=\"Arial\" color=\"$color{'framefont'}\">$Display{'30'}<\/font><\/td>
    <\/tr>
    <tr>
      <td width=\"100%\"><font size=\"1\"><b><i>/isg;


        $message =~ s/\[\/quote\]/\<\/b><\/i><\/font><\/td>
    <\/tr>
  <\/table>
  <\/center>
<\/div>

/isg;


        $message =~ s/\[fixed\]/<font face=\"Courier New\">/isg;
        $message =~ s/\[\/fixed\]/<\/font>/isg;

        $message =~ s/\[sup\]/<sup>/isg;
        $message =~ s/\[\/sup\]/<\/sup>/isg;

        $message =~ s/\[sub\]/<sub>/isg;
        $message =~ s/\[\/sub\]/<\/sub>/isg;

        $message =~ s/\[center\]/<center>/isg;
        $message =~ s/\[\/center\]/<\/center>/isg;

        $message =~ s/\[list\]/<ul>/isg;
        $message =~ s/\[\*\]/<li>/isg;
        $message =~ s/\[\/list\]/<\/ul>/isg;

        $message =~ s/\[pre\]/<pre>/isg;
        $message =~ s/\[\/pre\]/<\/pre>/isg;

        $message =~ s/\[code\]/<div align=\"center\">
  <center>
  <table border=\"1\" bordercolor=\"$color{'frame2'}\" width=\"90%\" cellspacing=\"0\" cellpadding=\"0\">
    <tr>
      <td width=\"100%\" bgcolor=\"$color{'frame2'}\"><font size=\"1\" face=\"Arial\" color=\"$color{'framefont'}\">$Display{'31'}<\/font><\/td>
    <\/tr>
    <tr>
      <td width=\"100%\"><font face=\"Courier New\" size=\"1\">/isg;


        $message =~ s/\[\/code\]/<\/font><\/td>
    <\/tr>
  <\/table>
  <\/center>
<\/div>

/isg;

        $message =~ s/\[email\](\S+?)\[\/email\]/<a href=\"mailto:$1\"\ target=\"_blank\">$1<\/a>/isg;

        $message =~ s/\[email=(\S+?)\]/<a href=\"mailto:$1\">/isg;
        $message =~ s/\[\/email\]/<\/a>/isg;

        $message =~ s/\[email=mailto:(\S+?)\]/<a href=\"mailto:$1\"\ target=\"_blank\">/isg;
        $message =~ s/\[\/email\]/<\/a>/isg;

        $message =~ s/(\[FLASH=)(\S+?)(\,)(\S+?)(\])(\S+?)(\[\/FLASH\])/<OBJECT CLASSID="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" WIDTH=$2 HEIGHT=$4><PARAM NAME=MOVIE VALUE=$6><PARAM NAME=PLAY VALUE=TRUE><PARAM NAME=LOOP VALUE=TRUE><PARAM NAME=QUALITY VALUE=HIGH><EMBED SRC=$6 WIDTH=$2 HEIGHT=$4 PLAY=TRUE LOOP=TRUE QUALITY=HIGH><\/EMBED><\/OBJECT>/isg;

        $message =~ s|\{\{|\[|g;
        $message =~ s|\}\}|\]|g;

        $message =~ s/(\[MOVE\])(.+?)(\[\/Move\])/<MARQUEE>$2<\/MARQUEE>/isg;

        $message =~ s/\ ftp:\/\/(\S+?)\ / <a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a> /isg;
        $message =~ s/<br>ftp:\/\/(\S+?)\ /<br><a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a>/isg;
        $message =~ s/^ftp:\/\/(\S+?)\ /<a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a>/isg;

        $message =~ s/\ gopher:\/\/(\S+?)\ / <a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a> /isg;
        $message =~ s/<br>gopher:\/\/(\S+?)\ /<br><a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a>/isg;
        $message =~ s/^gopher:\/\/(\S+?)\ /<a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a>/isg;

        $message =~ s/\ news:\/\/(\S+?)\ / <a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a> /isg;
        $message =~ s/<br>news:\/\/(\S+?)\ /<br><a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a>/isg;
        $message =~ s/^news:\/\/(\S+?)\ /<a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a>/isg;

        $message =~ s/\\ftp:\/\/(\S+)/<a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp:\/\/$1<\/a>/isg;
        $message =~ s/\\gopher:\/\/(\S+)/<a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher:\/\/$1<\/a>/isg;
        $message =~ s/\\news:\/\/(\S+)/<a href=\"news:\/\/$1\"\ target=\"_blank\">news:\/\/$1<\/a>/isg;
        $message =~ s/\\www\.\/\/(\S+)/<a href=\"http:\/\/www.$1\"\ target=\"_blank\">http:\/\/www.$1<\/a>/isg;
        $message =~ s/(\[SHADOW=)(\S+?)(\,)(.+?)(\,)(.+?)(\])(.+?)(\[\/SHADOW\])/<table width=$6 style="filter:shadow\(color=$2\, direction=$4)">$8<\/table>/isg;
        $message =~ s/(\[GLOW=)(\S+?)(\,)(.+?)(\,)(.+?)(\])(.+?)(\[\/GLOW\])/<table width=$6 style="filter:glow\(color=$2\, strength=$4)">$8<\/table>/isg;
        $message =~ s/(\[font=)(.+?)(\])(.+?)(\[\/font\])/<FONT face="$2">$4<\/FONT f>/isg;
        $message =~ s/(\[size=)(.+?)(\])(.+?)(\[\/size\])/<FONT size="$2">$4<\/FONT s>/isg;

        $message =~ s/\[news\](.+?)\[\/news\]/<a href=\"$1\">$1<\/a>/isg;
        $message =~ s/\[gopher\](.+?)\[\/gopher\]/<a href=\"$1\">$1<\/a>/isg;
        $message =~ s/\[ftp\](.+?)\[\/ftp\]/<a href=\"$1\">$1<\/a>/isg;

        $message =~ s/\[black\]/<font color=000000>/isg;
        $message =~ s/\[\/black\]/<\/font>/isg;

        $message =~ s/\[white\]/<font color=FFFFFF>/isg;
        $message =~ s/\[\/white\]/<\/font>/isg;

        $message =~ s/\[blue\]/<font color=0000FF>/isg;
        $message =~ s/\[\/blue\]/<\/font>/isg;

        $message =~ s/\[red\]/<font color=FF0000>/isg;
        $message =~ s/\[\/red\]/<\/font>/isg;

        $message =~ s/\[green\]/<font color=00FF00>/isg;
        $message =~ s/\[\/green\]/<\/font>/isg;

        $message =~ s/\[right\]/<p align=right>/isg;
        $message =~ s/\[\/right\]/<\/p>/isg;

        $message =~ s/\[left\]/<p align=left>/isg;
        $message =~ s/\[\/left\]/<\/p>/isg;

        $message =~ s/\[tt\]/<tt>/isg;
        $message =~ s/\[\/tt\]/<\/tt>/isg;

        $message =~ s/\[table\]/<table>/isg;
        $message =~ s/\[\/table\]/<\/table>/isg;

        $message =~ s/\[td\]/<td>/isg;
        $message =~ s/\[\/td\]/<\/td>/isg;

        $message =~ s/\[tr\]/<tr>/isg;
        $message =~ s/\[\/tr\]/<\/tr>/isg;
}
1;