###############################################################################
# InstantMessage.pl                                                           #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
# =========================================================================== #
###############################################################################
# $field[0] = From (username only)
# $field[1] = Subject
# $field[2] = Date
# $field[3] = Message
# $field[4] = MessageID
# $field[5] = IP

$openfolder = "<img src=\"$imagesdir/openfolder.gif\" border=0>";
$closedfolder = "<img src=\"$imagesdir/closedfolder.gif\" border=0>";

sub IMIndex {
        if ($username eq "Guest") {
                &fatal_error("$InstantMessage{'1'}");
        }

        # Read all messages

        open(FILE, "$memberdir/$username.msg");
        &lock(FILE);
        @messages = <FILE>;
        &unlock(FILE);
        close(FILE);

        # Read Membergroups

        $title = "$InstantMessage{'2'}";
        open(FILE, "$vardir/membergroups.txt");
        &lock(FILE);
        @membergroups = <FILE>;
        &unlock(FILE);
        close(FILE);

        # Read list of censored words

        open(CENSOR, "$vardir/censor.txt");
        &lock(CENSOR);
        @censored = <CENSOR>;
        &unlock(CENSOR);
        close(CENSOR);

        ########################################################################

        &header;
        &menu2;

        ########################################################################

print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
EOT

if ($nav_art eq "1") {
print <<"EOT";
<td valign=bottom>
<font size=$Fontsize face="$FontFace">$closedfolder &nbsp\;<b><a href="$boardurl/YaBB.pl">$mbname</a>&nbsp\; $closedfolder &nbsp\;<a href="$cgi&action=im">$InstantMessage{'3'}</a>&nbsp\; $openfolder &nbsp\;$InstantMessage{'4'}</b>
</font>
</td>
EOT
} else {
print <<"EOT";
<td valign=bottom>
        <FONT SIZE="1" FACE="Verdana, Arial">
        <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <A href="$boardurl/YaBB.pl">$mbname</A>
        <br>
        <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <a href="$cgi&action=im">$InstantMessage{'3'}</a>
        <br>
        <IMG SRC="$imagesdir/tline3.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$InstantMessage{'4'}
        </td>
EOT
}

print "<td align=right>";
print "<img src=\"$imagesdir/im_left.gif\" border=0>";
print <<"EOT";
<a href="$cgi&action=imoutbox"><img src="$imagesdir/im_outbox.gif" border=0 alt="$InstantMessage{'5'}"></a><a href="$cgi&action=imsend"><img src="$imagesdir/im_new.gif"  border=0 alt="$InstantMessage{'6'}"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 alt="$InstantMessage{'7'}"></a><a href="$cgi&action=imprefs"><img src="$imagesdir/im_config.gif" border=0  alt="$InstantMessage{'8'}"></a><img src="$imagesdir/im_right.gif" border=0 >
</td>
</table>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
 <td bgcolor="$color{'titlebg'}" width=140><font size=$Fontsize face="$FontFace" color="$color{'titletext'}">&nbsp;<b>$InstantMessage{'9'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'10'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'11'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}">&nbsp;</font></td>
</tr>
EOT

        # Display Message if there are no Messages in Users Inbox

        if(@messages==0) {
                print <<"EOT";
<tr>
        <td colspan=4 bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">$InstantMessage{'12'}</font></td>
</tr><font size=$Fontsize face=\"$FontFace\">
EOT
        }

        # Display all available Messages

        $second="$color{'windowbg2'}";

        for ($a = 0; $a < @messages; $a++) {

                if($second eq "$color{'windowbg'}") {
                        $second="$color{'windowbg2'}";
                } else {
                        $second="$color{'windowbg'}";
                }

                ($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a], $mips[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message

                if ($messageid[$a] < 100) {
                        $messageid[$a] = $a;
                }

                $name = "$mname[$a]";
                $date = "$mdate[$a]";
                $subject = "$msub[$a]";

                if($subject eq "") {
                        $subject="$InstantMessage{'13'}";
                }

                print "<tr>";
                print "<td bgcolor=\"$second\"><font size=$Fontsize face=\"$FontFace\">$date</font></td>";
                print "<td bgcolor=\"$second\"><font size=$Fontsize face=\"$FontFace\">$musername[$a]</font></td>";
                print "<td bgcolor=\"$second\"><a href=\"#$messageid[$a]\"><font size=$Fontsize face=\"$FontFace\">$subject</font></a></td>";
                print "<td bgcolor=\"$second\"><a href=\"$cgi&action=imremove&caller=1&id=$messageid[$a]\"><font size=$Fontsize face=\"$FontFace\">$InstantMessage{'14'}</font></a></td>";
                print "</tr>";

        }

print <<"EOT";
</table>
EOT

        ########################################################################
        # Output all messages

        if(@messages!=0) {

        print <<"EOT";
<br>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}">&nbsp;<b>$InstantMessage{'15'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'16'}</b></font></td>
</tr>
EOT

        if(@messages==0) {
                print <<"EOT";
<tr>
        <td colspan=2 bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">$InstantMessage{'12'}</font></td>
</tr>
EOT
        }

        $second="$color{'windowbg2'}";

        for ($a = 0; $a < @messages; $a++) {
                if($second eq "$color{'windowbg'}") {
                        $second="$color{'windowbg2'}";
                } else {
                        $second="$color{'windowbg'}";
                }

                ($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message

                if ($messageid[$a] < 100) {
                        $messageid[$a] = $a;
                }

                $subject = "$msub[$a]";

                if($subject eq "") {
                        $subject="$InstantMessage{'13'}";
                }
                $mmessage[$a] =~ s/[\n\r]//g;
                $message="$mmessage[$a]";
                $name = "$mname[$a]";
                $date = "$mdate[$a]";
                $ip = "$mip[$a]";
                $postinfo="";
                $signature="";
                $viewd="";
                $icq="";
                $star="";

                open(FILE, "$memberdir/$musername[$a].dat");
                &lock(FILE);
                @memset = <FILE>;
                &unlock(FILE);
                close(FILE);

                $postinfo = "$InstantMessage{'17'}: $memset[6]<br>";
                $viewd = " \| <a href=\"$cgi\&action=viewprofile\&username=$musername[$a]\">$InstantMessage{'18'}</a><br>";
                                                require "$sourcedir/Membergroups.pl";
                                                &memberstatus;
                $signature = "$memset[5]";
                $signature =~ s/\&\&/[br]/g;
                $signature = "[hr]$signature";
                $memset[8] =~ s/[\n\r]//g;
                if($memset[8] ne "") {
                if(!($memset[8] =~ /\D/)) {
                        $icq="<a href=\"javascript:openScript('$cgi\&action=icqpager&UIN=$memset[8]',450,300)\"><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
                        #$icq = "<a href=\"http://www.icq.com/$memset[8]\" target=_blank><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
                }
                }
                $message = "$message\n$signature";
                if($enable_ubbc) {
                        require "$sourcedir/Display.pl";
                        &DoUBBC;
                }
                $url="";
                if($memset[3] ne "\n" && $musername[$a] ne "Guest") {
                        $url= "<a href=\"$memset[4]\">WWW</a> \| ";
                }
                ##################
                foreach $censor (@censored) {
                        $censor =~ s/[\n\r]//g;
                        ($word, $censored) = split(/\=/, $censor);
                        $message =~ s/$word/$censored/g;
                        $subject =~ s/$word/$censored/g;
                }
                ##################
                print <<"EOT";
<tr>
        <td bgcolor="$second" width=140 valign=top rowspan=2>
        <font size=$Fontsize face="$FontFace"><b>$musername[$a]</b></font><br>
        <font size=$Fontsize1 face="$FontFace">$memberinfo<br>
        $star<br><br>
        $postinfo<br>
        $icq
        </font></td>
        <td bgcolor="$second" valign=top>
        <table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr>
        <td width=100%><a name="$messageid[$a]"><font size=$Fontsize1 face="$FontFace">&nbsp;<b>$subject</b></font></td>
        <td align=right nowrap><font size=$Fontsize1 face="$FontFace"><b>$InstantMessage{'9'}:</b> $date</font></td>
</tr>
</table>
        <hr></font>
<font size=$Fontsize face="$FontFace">
$message
</font></td>
</tr>
<tr>
        <td bgcolor="$second"><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=$Fontsize1 face="$FontFace">
$url<a href="mailto:$memset[2]">$InstantMessage{'19'}</a>$viewd
</font></td><td align=right>
<font size=$Fontsize1 face="$FontFace"><a href="$cgi&action=imsend&caller=1&num=$a&quote=1&to=$musername[$a]">$InstantMessage{'20'}</a> | <a href="$cgi&action=imsend&caller=1&to=$musername[$a]&num=$a">$InstantMessage{'21'}</a> | <a href="$cgi&action=imremove&caller=1&caller=1&id=$messageid[$a]"><b>$InstantMessage{'22'}</b></a></font></td></tr></table></td>
</tr>
EOT
;
        }
        print <<"EOT";
</table>
<font size=$Fontsize face="$FontFace"><a href="$cgi&action=imsend">$InstantMessage{'23'}</a></font>
EOT
}
        &footer;
        exit;
}

sub IMOutbox {
        if ($username eq "Guest") {
                &fatal_error("$InstantMessage{'1'}");
        }

        open(FILE, "$memberdir/$username.dat");
        &lock(FILE);
        @memset = <FILE>;
        &unlock(FILE);
        close(FILE);

        # Read all messages

        open(FILE, "$memberdir/$username.outbox");
        &lock(FILE);
        @messages = <FILE>;
        &unlock(FILE);
        close(FILE);

        # Read Membergroups

        $title = "$InstantMessage{'2'}";
        open(FILE, "$vardir/membergroups.txt");
        &lock(FILE);
        @membergroups = <FILE>;
        &unlock(FILE);
        close(FILE);

        # Read list of censored words

        open(CENSOR, "$vardir/censor.txt");
        &lock(CENSOR);
        @censored = <CENSOR>;
        &unlock(CENSOR);
        close(CENSOR);

        ##################

        &header;

        #####


print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
EOT

if ($nav_art eq "1") {
print <<"EOT";
<td valign=bottom>
<font size=$Fontsize face="$FontFace">$closedfolder &nbsp\;<b><a href="$boardurl/YaBB.pl">$mbname</a>&nbsp\; $closedfolder &nbsp\;<a href="$cgi&action=im">$InstantMessage{'3'}</a>&nbsp\; $openfolder &nbsp\;$InstantMessage{'5'}</b>
</font>
</td>
EOT
} else {
print <<"EOT";
<td valign=bottom>
        <FONT SIZE="1" FACE="Verdana, Arial">
        <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <A href="$boardurl/YaBB.pl">$mbname</A>
        <br>
        <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <a href="$cgi&action=im">$InstantMessage{'3'}</a>
        <br>
        <IMG SRC="$imagesdir/tline3.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$InstantMessage{'5'}
        </td>
EOT
}

print "<td align=right>";
        print "<img src=\"$imagesdir/im_left.gif\" border=0 >";
        if ($INFO{'id'} > 0) {
                print "<a href=\"$cgi&action=imsend&num=$INFO{'num'}&quote=2\"><img src=\"$imagesdir/im_forward.gif\" border=0 alt=\"$InstantMessage{'24'}\"></a>";
                print "<a href=\"$cgi&action=imremove&caller=2&id=$INFO{'id'}\"><img src=\"$imagesdir/im_delete.gif\" border=0 alt=\"$InstantMessage{'14'}\"></a>";
                print "<img src=\"$imagesdir/im_spacer.gif\" border=0>";
        }
        print <<"EOT";
<a href="$cgi&action=im"><img src="$imagesdir/im_inbox.gif" border=0 alt="Inbox"></a><a href="$cgi&action=imsend"><img src="$imagesdir/im_new.gif" border=0 alt="$InstantMessage{'23'}"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 alt="$InstantMessage{'7'}"></a><a href="$cgi&action=imprefs"><img src="$imagesdir/im_config.gif" border=0 alt="$InstantMessage{'8'}"></a><img src="$imagesdir/im_right.gif" border=0>
</td>
</table>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
 <td bgcolor="$color{'titlebg'}" width=140><font size=$Fontsize face="$FontFace" color="$color{'titletext'}">&nbsp;<b>$InstantMessage{'9'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'25'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'11'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}">&nbsp;</font></td>
</tr>
EOT

        # Display Message if there are no Messages in Users Outbox

        if(@messages==0) {
                print <<"EOT";
<tr>
        <td colspan=4 bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">$InstantMessage{'12'}</font></td>
</tr>
EOT
        }

        # Display all available Messages

        $second="$color{'windowbg2'}";

        for ($a = 0; $a < @messages; $a++) {

                if($second eq "$color{'windowbg'}") {
                        $second="$color{'windowbg2'}";
                } else {
                        $second="$color{'windowbg'}";
                }

                ($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a], $mips[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message

                if ($messageid[$a] < 100) {
                        $messageid[$a] = $a;
                }

                $name = "$mname[$a]";
                $date = "$mdate[$a]";
                $subject = "$msub[$a]";

                if($subject eq "") {
                        $subject="$InstantMessage{'13'}";
                }

                print "<tr>";
                print "<td bgcolor=\"$second\"><font size=$Fontsize face=\"$FontFace\">$date</font></td>";
                print "<td bgcolor=\"$second\"><font size=$Fontsize face=\"$FontFace\">$musername[$a]</font></td>";
                print "<td bgcolor=\"$second\"><a href=\"#$messageid[$a]\"><font size=$Fontsize face=\"$FontFace\">$subject</font></a></td>";
                print "<td bgcolor=\"$second\"><a href=\"$cgi&action=imremove&caller=2&id=$messageid[$a]\"><font size=$Fontsize face=\"$FontFace\">$InstantMessage{'14'}</font></a></td>";
                print "</tr>";

        }

print <<"EOT";
</table>
EOT

        #####

        # Output all messages

        if(@messages!=0) {

        print <<"EOT";
<br>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}">&nbsp;<b>$InstantMessage{'15'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'16'}</b></font></td>
</tr>
EOT

        if(@messages==0) {
                print <<"EOT";
<tr>
        <td colspan=2 bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">$InstantMessage{'12'}</font></td>
</tr>
EOT
        }

        $second="$color{'windowbg2'}";

        for ($a = 0; $a < @messages; $a++)
        {
                if($second eq "$color{'windowbg'}")
                {
                        $second="$color{'windowbg2'}";
                }
                else
                {
                        $second="$color{'windowbg'}";
                }

                ($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message

                if ($messageid[$a] < 100) {
                        $messageid[$a] = $a;
                }

                $subject = "$msub[$a]";

                if($subject eq "") {
                        $subject="$InstantMessage{'13'}";
                }

                $mmessage[$a] =~ s/[\n\r]//g;
                $message="$mmessage[$a]";
                $name = "$mname[$a]";
                $date = "$mdate[$a]";
                $ip = "$mip[$a]";
                $postinfo="";
                $signature="";
                $viewd="";
                $icq="";
                $star="";

                $postinfo = "$InstantMessage{'17'}: $memset[6]<br>";
                $viewd = " \| <a href=\"$cgi\&action=viewprofile\&username=$musername[$a]\">$InstantMessage{'18'}</a><br>";
                                                require "$sourcedir/Membergroups.pl";
                                                &memberstatus;
                $signature = "$memset[5]";
                $signature =~ s/\&\&/<br>/g;
                $signature = "[hr]$signature";
                $memset[8] =~ s/[\n\r]//g;
                if($memset[8] ne "") {
                if(!($memset[8] =~ /\D/)) {
                        $icq="<a href=\"javascript:openScript('$cgi\&action=icqpager&UIN=$memset[8]',450,300)\"><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
                }
                }
                $message = "$message\n$signature";
                if($enable_ubbc) {
                        require "$sourcedir/Display.pl";
                        &DoUBBC;
                }
                $url="";
                if($memset[3] ne "\n" && $musername[$a] ne "Guest") {
                        $url= "<a href=\"$memset[4]\">WWW</a> \| ";
                }
                ##################
                foreach $censor (@censored) {
                        $censor =~ s/[\n\r]//g;
                        ($word, $censored) = split(/\=/, $censor);
                        $message =~ s/$word/$censored/g;
                        $subject =~ s/$word/$censored/g;
                }
                ##################
                print <<"EOT";
<tr>
        <td bgcolor="$second" width=140 valign=top rowspan=2>
        <font size=$Fontsize face="$FontFace"><b>$musername[$a]</b></font><br>
        <font size=$Fontsize1 face="$FontFace">$memberinfo<br>
        $star<br><br>
        $postinfo<br>
        $icq
        </font></td>
        <td bgcolor="$second" valign=top>
        <table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr>
        <td width=100%><font size=$Fontsize1 face="$FontFace"><a name="$messageid[$a]">&nbsp;<b>$subject</b></font></td>
        <td align=right nowrap><font size=$Fontsize1 face="$FontFace"><b>$InstantMessage{'9'}:</b> $date</font></td>
</tr>
</table>
        <hr></font>
<font size=$Fontsize face="$FontFace">
$message
</font></td>
</tr>
<tr>
        <td bgcolor="$second"><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=$Fontsize1 face="$FontFace">
$url<a href="mailto:$memset[2]">E-Mail</a>$viewd
</font></td><td align=right>
<font size=$Fontsize1 face="$FontFace"><a href="$cgi&action=imsend&caller=2&num=$a&quote=1&to=$musername[$a]">$InstantMessage{'20'}</a> | <a href="$cgi&action=imsend&caller=2&to=$musername[$a]&num=$a">$InstantMessage{'21'}</a> | <a href="$cgi&action=imremove&caller=2&id=$messageid[$a]"><b>$InstantMessage{'22'}</b></a></font></td></tr></table></td>
</tr>
EOT
;
        }
        print <<"EOT";
</table>
<font size=$Fontsize face="$FontFace"><a href="$cgi&action=imsend">$InstantMessage{'6'}</a></font>
EOT
}
        &footer;
        exit;
}

#####
#
# Remove Message from Inbox/Outbox
#
#####

sub IMRemove {
        &checkdomain;

        if($username eq "Guest") {
                &fatal_error("$InstantMessage{'1'}");
        }

        if ($INFO{'caller'} == 1) {
                open(FILE, "$memberdir/$username.msg");
        } elsif ($INFO{'caller'} == 2) {
                open(FILE, "$memberdir/$username.outbox");
        }

        &lock(FILE);
        @messages = <FILE>;
        &unlock(FILE);
        close(FILE);

        if ($INFO{'caller'} == 1) {
                open(FILE, ">$memberdir/$username.msg");
        } elsif ($INFO{'caller'} == 2) {
                open(FILE, ">$memberdir/$username.outbox");
        }
        &lock(FILE);

        for ($a = 0; $a < @messages; $a++) {
                # ONLY delete MSG with correct ID
                ($musername, $msub, $mdate, $mmessage, $messageid, $mips) = split(/\|/,$messages[$a]);

                $messageid =~ s/[\n\r]//g; # this line is necessary !!!

                # If Message-ID is < 100, user has used the old IM before
                if ($messageid < 100 ) {
                        if($a ne $INFO{'id'}) {
                                    print FILE "$messages[$a]";
                         }
                } else {
                         if($messageid ne "$INFO{'id'}") {
                                    print FILE "$messages[$a]";
                         }
                      }
           }

           &unlock(FILE);
           close(FILE);

        if ($INFO{'caller'} == 1) {
                   print "Location: $cgi\&action=im\n\n";
           } else {
                   print "Location: $cgi\&action=imoutbox\n\n";
           }

}

#####
#
# Write new Message
#
#####

sub IMPost {
        if($username eq "Guest") {
                 &fatal_error("$InstantMessage{'1'}");
        }

        $title="$InstantMessage{'6'}";
        &header;
        if($INFO{'num'} ne "") {

                if($INFO{'caller'} == 1) {
                        open(FILE, "$memberdir/$username.msg");
                } else {
                        open(FILE, "$memberdir/$username.outbox");
                }

                &lock(FILE);
                @messages = <FILE>;
                &unlock(FILE);
                close(FILE);

                ($mfrom, $msubject, $mdate, $mmessage, $mip) = split(/\|/,$messages[$INFO{'num'}]);
                $msubject =~ s/Re: //g;

                if($INFO{'quote'} == 1) {
                        $mmessage =~ s/<br>/\n/g;
                        $form_message =~ s/\[quote\](\S+?)\[\/quote\]//isg;
                        $form_message =~ s/\[(\S+?)\]//isg;
                        $form_message = "\n\n\[quote\]$mmessage\[/quote\]";
                        $form_subject = "Re: $msubject";
                }

        }


print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
EOT

if ($nav_art eq "1") {
print <<"EOT";
<td valign=bottom>
<font size=$Fontsize face="$FontFace">$closedfolder &nbsp\;<b><a href="$boardurl/YaBB.pl">$mbname</a>&nbsp\; $closedfolder &nbsp\;<a href="$cgi&action=im">$InstantMessage{'3'}</a>&nbsp\; $openfolder &nbsp\;$InstantMessage{'5'}</b>
</font>
</td>
EOT
} else {
print <<"EOT";
<td valign=bottom>
        <FONT SIZE="1" FACE="Verdana, Arial">
        <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <A href="$boardurl/YaBB.pl">$mbname</A>
        <br>
        <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <a href="$cgi&action=im">$InstantMessage{'3'}</a>
        <br>
        <IMG SRC="$imagesdir/tline3.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$InstantMessage{'5'}
        </td>
EOT
}

print "<td align=right>";
        print "<img src=\"$imagesdir/im_left.gif\" border=0>";
        print <<"EOT";
<a href="$cgi&action=im"><img src="$imagesdir/im_inbox.gif" border=0 alt="$InstantMessage{'4'}"></a><a href="$cgi&action=imoutbox"><img src="$imagesdir/im_outbox.gif" border=0 alt="$InstantMessage{'5'}"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 alt="$InstantMessage{'7'}"></a><a href="$cgi&action=imprefs"><img src="$imagesdir/im_config.gif" border=0 alt="$InstantMessage{'8'}"></a><img src="$imagesdir/im_right.gif" border=0>
</td>
</table>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'6'}</b></font></td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <form action="$cgi&action=imsend2" method=post>
    <table border=0>
     <tr>
      <td>
       <font size=$Fontsize face="$FontFace"><b>$InstantMessage{'26'}:</b></font>
      </td>
      <td>
       <input type=text name="to" value="$INFO{'to'}" size="20" maxlength="50">
      </td>
     </tr>
     <tr>
      <td>
       <font size=$Fontsize face="$FontFace"><b>$InstantMessage{'11'}:</b></font>
      </td>
      <td>
       <font size=$Fontsize face="$FontFace"><input type=text name="subject" value="$form_subject" size="40" maxlength="50"></font>
      </td>
     </tr>
     <tr>
      <td valign=top>
       <font size=$Fontsize face="$FontFace"><b>$InstantMessage{'27'}:</b></font>
      </td>
      <td>
       <font size=$Fontsize face="$FontFace"><textarea name=message rows=10 cols=50 wrap=physical>$form_message</textarea>
      </td>
     </tr>
     <tr>
      <td align=center colspan=2>
       <input type=submit value="$InstantMessage{'29'}">
       <input type=reset value="$InstantMessage{'28'}">
      </td>
     </tr>
    </table>
   </form>
  </td>
 </tr>
</table>
EOT
        &footer;
        exit;
}

#####
#
# Write new Message
#
#####

sub IMPost2 {
        &checkdomain;
        # Check Ignore-List

        if (-e("$memberdir/$FORM{'to'}.imconfig")) {

                open(FILE, "$memberdir/$FORM{'to'}.imconfig");
                &lock(FILE);
                @imconfig = <FILE>;
                &unlock(FILE);
                close(FILE);

                # Build Ignore-List

                $imconfig[0] =~ s/[\n\r]//g;
                $imconfig[1] =~ s/[\n\r]//g;

                @ignore = split(/\|/,$imconfig[0]);

                # If User is on Recepients Ignor-List, show Error-Message

                foreach $igname (@ignore) {
                        if ($igname eq $username) {
                                &fatal_error("$InstantMessage{'30'}");
                        }
                }

        }

        # Create unique Message ID = Time & ProccessID

        $messageid = $^T.$$;

        # ---

        $subject = $FORM{'subject'};
        $message = $FORM{'message'};

        &fatal_error("$InstantMessage{'31'}") unless($subject);
        &fatal_error("$InstantMessage{'32'}") unless($message);

        $mmessage = $message;
        $msubject = $subject;

        $subject =~ s/\&/\&amp;/g;
        $message =~ s/\&/\&amp;/g;
        $subject =~ s/"/\&quot;/g;
        $message =~ s/"/\&quot;/g;
        $subject =~ s/  / \&nbsp;/g;
        $message =~ s/  / \&nbsp;/g;

        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/\|/\&#124;/g;
        $message =~ s/</&lt;/g;
        $message =~ s/>/&gt;/g;
        $message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
        $message =~ s/\cM//g;
        $message =~ s/\n/<br>/g;
        $message =~ s/\|/\&#124;/g;

        if (!(-e("$memberdir/$FORM{'to'}.dat"))) {
                &fatal_error("$InstantMessage{'33'}");
        }

        # Add message to outbox

        if(-e("$memberdir/$username.outbox")) {
                open (FILE, ">>$memberdir/$username.outbox");
        } else {
                open (FILE, ">$memberdir/$username.outbox");
        }

        &lock(FILE);
        print FILE "$FORM{'to'}\|$subject\|$date\|$message\|$messageid\|$ENV{'REMOTE_ADDR'}\n";
        &unlock(FILE);
        close (FILE);

        # Send message to user

        open (FILE, ">>$memberdir/$FORM{'to'}.msg");
        &lock(FILE);
        print FILE "$username\|$subject\|$date\|$message\|$messageid\|$ENV{'REMOTE_ADDR'}\n";
        &unlock(FILE);
        close(FILE);

        # Send notification

        if ($imconfig[1]==1) {

                open (FILE, "$memberdir/$FORM{'to'}.dat");
                &lock(FILE);
                @recepient = <FILE>;
                &unlock(FILE);
                close(FILE);

                $recepient[2] =~ s/[\n\r]//g; # get eMail-Adress

                if ($recepient[2] ne "") {

                        &sendmail("$recepient[2]","$InstantMessage{'6'} ($msubject)","($date) $username $InstantMessage{'34'}\n\n->*<-\n\n$mmessage\n\n->*<-");

                }

        }

        print "Location: $cgi\&action=im\n\n";
        exit;
}

#####
#
# Set Preferences
#
#####

sub IMPreferences {
        if ($username eq "Guest") {
                &fatal_error("$InstantMessage{'1'}");
        }

        if (-e("$memberdir/$username.imconfig")) {
                open(FILE, "$memberdir/$username.imconfig");
                &lock(FILE);
                @imconfig = <FILE>;
                &unlock(FILE);
                close(FILE);
        }

        $imconfig[0] =~ s/[\n\r]//g;
        $imconfig[0] =~ s/\|/\n/g;
        $imconfig[1] =~ s/[\n\r]//g;

        if ($imconfig[1]) {
                $sel0="";
                $sel1=" selected";
        } else {
                $sel0=" selected";
                $sel1="";
        }

        &header;

print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
EOT

if ($nav_art eq "1") {
print <<"EOT";
<td valign=bottom>
<font size=$Fontsize face="$FontFace">$closedfolder &nbsp\;<b><a href="$boardurl/YaBB.pl">$mbname</a>&nbsp\; $closedfolder &nbsp\;<a href="$cgi&action=im">$InstantMessage{'3'}</a>&nbsp\; $openfolder &nbsp\;$InstantMessage{'8'}</b>
</font>
</td>
EOT
} else {
print <<"EOT";
<td valign=bottom>
        <FONT SIZE="1" FACE="Verdana, Arial">
        <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <A href="$boardurl/YaBB.pl">$mbname</A>
        <br>
        <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
        <a href="$cgi&action=im">$InstantMessage{'3'}</a>
        <br>
        <IMG SRC="$imagesdir/tline3.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$InstantMessage{'8'}
        </td>
EOT
}

print "<td align=right>";
        print "<img src=\"$imagesdir/im_left.gif\" border=0>";
        print <<"EOT";
<a href="$cgi&action=im"><img src="$imagesdir/im_inbox.gif" border=0 alt="$InstantMessage{'4'}"></a><a href="$cgi&action=imoutbox"><img src="$imagesdir/im_outbox.gif" border=0 alt="$InstantMessage{'5'}"></a><a href="$cgi&action=imsend"><img src="$imagesdir/im_new.gif" border=0 alt="$InstantMessage{'6'}"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 alt="$InstantMessage{'7'}"></a><img src="$imagesdir/im_right.gif" border=0>
</td>
</table>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$InstantMessage{'8'}</b></font></td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <form action="$cgi&action=imprefs2" method=post>
    <table border=0>
     <tr>
      <td valign=top>
       <font size=$Fontsize face="$FontFace"><b>$InstantMessage{'35'}:</b></font><br><font size=$Fontsize1 face="$FontFace">$InstantMessage{'36'}</font>
      </td>
      <td>
       <font size=$Fontsize face="$FontFace"><textarea name=ignore rows=10 cols=50 wrap=virtual>$imconfig[0]</textarea></font>
      </td>
     </tr>
     <tr>
      <td valign=top>
       <font size=$Fontsize face="$FontFace"><b>$InstantMessage{'37'}:</b></font>
      </td>
      <td>
       <font size=$Fontsize face="$FontFace">
        <select name="notify">
         <option value="0"$sel0>$InstantMessage{'38'}
         <option value="1"$sel1>$InstantMessage{'39'}
        </select>
       </font>
      </td>
     </tr>
     <tr>
      <td>
              &nbsp;
      </td>
      <td>
       <input type=submit value="$InstantMessage{'40'}">
       <input type=reset value="$InstantMessage{'28'}">
      </td>
     </tr>
    </table>
   </form>
  </td>
 </tr>
</table>
EOT
        &footer;
        exit;

}

sub IMPreferences2 {
        &checkdomain;
        if($username eq "Guest") {
                 &fatal_error("$InstantMessage{'1'}");
        }

        $ignorelist = "$FORM{'ignore'}";
        $notify = "$FORM{'notify'}";

        $ignorelist =~ s/[\n\r]/\|/g;
        $ignorelist =~ s/\|\|/\|/g;
        $notify =~ s/[\n\r]//g;

        open(FILE, ">$memberdir/$username.imconfig");
        &lock(FILE);

        print FILE $ignorelist."\n";
        print FILE $notify."\n";

        &unlock(FILE);
        close(FILE);

        print "Location: $cgi\&action=imprefs\n\n";
        exit;
}

1;