###############################################################################
# ManageCats.pl                                                               #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub ManageCats {
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageCats{'1'}"); }
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        $title = "$ManageCats{'2'}";
        $catsdropdown="";
        $catlist="";
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                $catsdropdown="$catsdropdown<option>$curcat";
                $catlist="$catlist\n$curcat";
        }
        &header;
        &menu2;
        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$ManageCats{'2'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'catbg'}"><font size=$Fontsize face="$FontFace"><b>$ManageCats{'3'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}">
<table border=0 width=100% cellspacing=1 bgcolor="$color{'windowbg'}">
EOT
        for ($a = 0; $a < @categories; $a++) {
        $categories[$a] =~ s/[\n\r]//g;
    open(FILE, "$boardsdir/$categories[$a].cat") || &fatal_error("$categories[$a].cat");
    &lock(FILE);
    @memsettings=<FILE>;
    &unlock(FILE);
    close(FILE);
        $memsettings[0] =~ s/[\n\r]//g;
        $memsettings[1] =~ s/[\n\r]//g;
        print <<"EOT";
        <tr><td bgcolor="$color{'windowbg'}"><form action="$cgi&action=modcat" method="POST">
                $ManageCats{'10'}: <input type=hidden size=15 name="catid" value="$categories[$a]"><input type=text size=15 value="$categories[$a]" disabled>&nbsp;
                $ManageCats{'11'}: <input type=text size=40 name="catname" value="$memsettings[0]"><br>
                $ManageCats{'12'}: <input type=text size=40 name="memgroup" value="$memsettings[1]"> ($ManageCats{'13'})<hr>
        </td><td><input type=submit value="$ManageCats{'4'}"></form></td></tr>
EOT
        }
        print <<"EOT";
</table>
</td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}" valign=top><font size=$Fontsize face="$FontFace">
<form action="$cgi&action=modifycatorder" method="POST">
<b>$ManageCats{'5'}:</b><br>
<textarea name="cats" cols="40" rows="4">$catlist</textarea><br>
<input type=submit value="$ManageCats{'6'}">
</form>
<form action="$cgi&action=removecat" method="POST">
<b>$ManageCats{'7'}:</b><br><select name="cat">$catsdropdown</select><input type=submit value="$ManageCats{'8'}">
</form>
<form action="$cgi&action=createcat" method="POST">
<b>$ManageCats{'9'}:</b><br>
$ManageCats{'10'}:<br> <input type=text size=15 name="catid"><br>
$ManageCats{'11'}:<br> <input type=text size=40 name="catname"><br>
$ManageCats{'12'}:<br> <input type=text size=40 name="memgroup"> ($ManageCats{'13'})<br>
<input type=submit value="$ManageCats{'14'}">
</form>
        </font></td>
</tr>
</table>
EOT
        &footer;
        exit;
}

sub ReorderCats {
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageCats{'1'}"); }
        $FORM{'cats'} =~ s/\r//g;
        open(FILE, ">$vardir/cat.txt");
        &lock(FILE);
        print FILE "$FORM{'cats'}";
        &unlock(FILE);
        close(FILE);
        print "Location: $cgi\&action=managecats\n\n";
        exit;
}

sub CreateCat {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageCats{'1'}"); }
        $catid="$FORM{'catid'}";
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        open(FILE, ">$vardir/cat.txt");
        &lock(FILE);
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                print FILE "$curcat\n";
        }
        print FILE "$catid";
        &unlock(FILE);
        close(FILE);
        open(FILE, ">$boardsdir/$catid.cat");
        print FILE "$FORM{'catname'}\n";
        print FILE "$FORM{'memgroup'}\n";
        close(FILE);
        print "Location: $cgi\&action=managecats\n\n";
        exit;
}

sub RemoveCat {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageCats{'1'}"); }
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        $title = "$ManageCats{'15'}";
        $newcatlist="";
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                if($curcat ne "$FORM{'cat'}") { $newcatlist="$newcatlist$curcat\n"; }
        }
        open(FILE, ">$vardir/cat.txt");
        &lock(FILE);
        print FILE "$newcatlist";
        &unlock(FILE);
        close(FILE);
        &header;
        $curcat="$FORM{'cat'}";

        open(CAT, "$boardsdir/$curcat.cat");
        &lock(CAT);
        @catinfo = <CAT>;
        &unlock(CAT);
        close(CAT);
        $curcatname="$catinfo[0]";
        foreach $curboard (@catinfo) {
                $curboard =~ s/[\n\r]//g;
                if($curboard ne "$catinfo[0]") {
                        open(BOARDDATA, "$boardsdir/$curboard.txt");
                        &lock(BOARDDATA);
                        @messages = <BOARDDATA>;
                        &unlock(BOARDDATA);
                        close(BOARDDATA);
                        foreach $curmessage (@messages) {
                                ($id, $dummy) = split(/\|/, $curmessage);
                                unlink("$datadir/$id\.txt");
                                unlink("$datadir/$id\.mail");
                                print "$ManageCats{'16'} $id<br>";
                        }
                }
                unlink("$boardsdir/$curboard.txt");
                unlink("$baordsdir/$curboard.mail");
                unlink("$boardsdir/$curboard.dat");
                print "$ManageCats{'17'}<br>";
        }
        unlink("$boardsdir/$curcat.cat");
        print "$ManageCats{'18'}<br>";
        print "$ManageCats{'19'}";
        &footer;
        exit;
}
sub ModCat {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageCats{'1'}"); }
        $catid="$FORM{'catid'}";
        open(FILE, "$boardsdir/$catid.cat") || &fatal_error("$catid.cat");
        &lock(FILE);
        @catinfo = <FILE>;
        &unlock(FILE);
        close(FILE);
        open(FILE, ">$boardsdir/$catid.cat") || &fatal_error("$catid.cat");
        &lock(FILE);
        for ($a=0;$a < @catinfo; $a++) {
                $catinfo[$a] =~ s/[\n\r]//g;
                if ($a eq "0") {
                        print FILE "$FORM{'catname'}\n";
                } elsif ($a eq "1") {
                        print FILE "$FORM{'memgroup'}\n";
                } else {
                        print FILE "$catinfo[$a]\n";
                }
        }
        &unlock(FILE);
        close(FILE);
        print "Location: $cgi\&action=managecats\n\n";
        exit;
}
1;
