###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub MoveThread {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$MoveThread{'1'}"); }
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        $title = "$MoveThread{'2'}";
        $boardlist="";
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                open(CAT, "$boardsdir/$curcat.cat");
                &lock(CAT);
                @catinfo = <CAT>;
                &unlock(CAT);
                close(CAT);
                $catinfo[1] =~ s/[\n\r]//g;
                $curcatname="$catinfo[0]";
                foreach $curboard (@catinfo) {
                        if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
                                $curboard =~ s/[\n\r]//g;
                                $boardlist="$boardlist<option>$curboard";
                        }
                }
        }
        ############################
        &header;
        &menu2;
        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$MoveThread{'2'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">
<form action="$cgi&action=movethread2&thread=$INFO{'thread'}" method="POST">
<b>$MoveThread{'3'}:</b> <select name="toboard">$boardlist</select>
<input type=submit value="Move">
</form>
</font></td>
</tr>
</table>
EOT
        &footer;
        exit;
}

sub MoveThread2 {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$MoveThread{'1'}"); }
        $thread="$INFO{'thread'}";
        open (FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$MoveThread{'4'} $currentboard.txt");
        &lock(FILE);
        @threads = <FILE>;
        &unlock(FILE);
        close (FILE);
        open (FILE, ">$boardsdir/$currentboard.txt") || &fatal_error("$MoveThread{'4'} $currentboard.txt");
        &lock(FILE);
        for ($a = 0; $a < @threads; $a++) {
                ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$threads[$a]);
                $mattach =~ s/[\n\r]//g;
                if ($mnum ne "$thread") { print FILE "$threads[$a]"; }
                else { $linetowrite="$threads[$a]"; }
        }
        &unlock(FILE);
        close(FILE);

        open (FILE, "$boardsdir/$FORM{'toboard'}.txt") || &fatal_error("$MoveThread{'4'} $INFO{'toboard'}.txt");
        &lock(FILE);
        @threads = <FILE>;
        &unlock(FILE);
        close (FILE);
        open (FILE, ">$boardsdir/$FORM{'toboard'}.txt") || &fatal_error("$MoveThread{'4'} $FORM{'toboard'}.txt");
        &lock(FILE);
        print FILE "$linetowrite";
        foreach $line (@threads) {
                print FILE "$line";
        }
        &unlock(FILE);
        close(FILE);

        open (BOARDINFO, "$boardsdir/$FORM{'toboard'}.dat") || &fatal_error("$MoveThread{'4'} $FORM{'toboard'}.dat");
        &lock(BOARDINFO);
        @boardinfo = <BOARDINFO>;
        &unlock(BOARDINFO);
        close (BOARDINFO);
        $boardname = "$boardinfo[0]";

        open (RECENT, "$vardir/recentpost.txt") || &fatal_error("$MoveThread{'4'} recentpost.txt");
        &lock(RECENT);
        @recentpost = <RECENT>;
        &unlock(RECENT);
        close (RECENT);
        open (RECENT, ">$vardir/recentpost.txt") || &fatal_error("$MoveThread{'4'} recentpost.txt");
        &lock(RECENT);
        for ($a = 0; $a < @recentpost; $a++) {
                ($mnum, $mboard, $mposter, $mtitle, $mboardname) = split(/\|/,$recentpost[$a]);
                $mattach =~ s/[\n\r]//g;
                if ($mnum ne "$thread") { print RECENT "$recentpost[$a]"; }
                else { print RECENT "$mnum\|$FORM{'toboard'}\|$mposter\|$mtitle\|$boardname"; }
        }
        &unlock(RECENT);
        close(RECENT);

        print "Location: $boardurl/YaBB.pl\?board=$FORM{'toboard'}\&action=display\&num=$INFO{'thread'}\n\n";
        exit;

}

1;
