###############################################################################
# ModifyMessage.pl                                                            #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################
&guest_login;
&SmileMapper;
sub ModifyMessage {
        open(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$ModifyMessage{'1'} $currentboard.txt");
        &lock(FILE);
        @threads = <FILE>;
        &unlock(FILE);
        close(FILE);
        for ($x = 0; $x < @threads; $x++) {
($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$threads[$x]);
                if ($INFO{'thread'} eq $mnum && $mstate==1) {
                        &fatal_error("$ModifyMessage{'2'}");
                        $x=@threads;
                }
        }

        $title = "$ModifyMessage{'3'}";
        $viewnum = $INFO{'message'};
        $viewnum = int ( $viewnum );

        open (FILE, "$datadir/$INFO{'thread'}.txt") || &fatal_error("$ModifyMessage{'1'} $INFO{'thread'}.txt");
        &lock(FILE);
        @messages = <FILE>;
        &unlock(FILE);
        close(FILE);

        ($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage, $mns) = split(/\|/,$messages[$viewnum]);
        $mmessage =~ s/<br>/\n/g;

        if($musername ne "$username" && $moderators{$username} eq "" && $settings[7] ne "Administrator" || $username eq "Guest") {
                &fatal_error("$ModifyMessage{'4'}");
        }
        $mns =~ s/[\n\r]//g;
        if ($mns ne "") {
                $thens = "checked";
        }

        &header;
        &menu2;
print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$ModifyMessage{'3'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}">
<form action="$cgi&action=modify2" method=post name="creator">
<input type=hidden name="viewnum" value="$viewnum">
<input type=hidden name="thread" value="$INFO{'thread'}">
<table border=0>
<tr>
        <td><font size=$Fontsize face="$FontFace"><b>$ModifyMessage{'5'}:</b></font></td>
        <td><font size=$Fontsize face="$FontFace">$musername</font></td>
</tr>
<tr>
        <td><font size=$Fontsize face="$FontFace"><b>$ModifyMessage{'6'}:</b></font></td>
        <td><font size=$Fontsize face="$FontFace">$memail</font></td>
</tr>
<tr>
        <td><font size=$Fontsize face="$FontFace"><b>$ModifyMessage{'7'}:</b></font></td>
        <td><font size=$Fontsize face="$FontFace"><input type=text name="subject" value="$msubject"></font></td>
</tr>
<tr>
        <td><font size=$Fontsize face="$FontFace"><b>$ModifyMessage{'8'}:</b></font></td>
        <td><input type="radio" value="$micon" name="icon" checked> <img src="$imagesdir/$micon.gif"> $ModifyMessage{'9'}<br>
                <input type="radio" value="xx" name="icon"> <img src="$imagesdir/xx.gif"  >
        <input type="radio" value="thumbup" name="icon"> <img src="$imagesdir/thumbup.gif"  >
        <input type="radio" value="thumbdown" name="icon"> <img src="$imagesdir/thumbdown.gif">
        <input type="radio" value="exclamation" name="icon"> <img src="$imagesdir/exclamation.gif" >
        <input type="radio" value="question" name="icon"> <img src="$imagesdir/question.gif" >
        <input type="radio" value="lamp" name="icon"> <img src="$imagesdir/lamp.gif"  >
        <input type="radio" value="smiley" name="icon"> <img src="$imagesdir/smiley.gif"  ><BR>
        <input type="radio" value="angry" name="icon"> <img src="$imagesdir/angry.gif"  >
        <input type="radio" value="cheesy" name="icon"> <img src="$imagesdir/cheesy.gif"  >
        <input type="radio" value="laugh" name="icon"> <img src="$imagesdir/laugh.gif"  >
        <input type="radio" value="sad" name="icon"> <img src="$imagesdir/sad.gif" alt="Sad" >
        <input type="radio" value="wink" name="icon"> <img src="$imagesdir/wink.gif"  > </td>
</tr>
EOT
&codebuttons;
print <<"EOT";
$codebuttons
<tr>
        <td valign=top><font size=$Fontsize face="$FontFace"><b>$ModifyMessage{'10'}:</b></font><br>$SmileMapper</td>
        <td><font size=$Fontsize face="$FontFace"><textarea name=message rows=10 cols=50 wrap=virtual>$mmessage</textarea></td>
</tr>
<tr>
        <td><font size=$Fontsize face="$FontFace"><b>$ModifyMessage{'11'}:</b></font></td>
        <td><font size=$Fontsize face="$FontFace"><input type=checkbox name="ns" value="NS" $thens></font></td>
</tr>
<tr>
        <td align=center colspan=2>
        <input type=submit name="moda" value="$ModifyMessage{'12'}">
        <input type=submit name="moda" value="$ModifyMessage{'13'}">
        </td>
</tr>
</table></form>
</td>
</tr>
</table>
EOT
        &footer;
        exit;
}

sub ModifyMessage2 {
        &checkdomain;
        if($INFO{'d'} eq "1") {

                if($moderators{$username} eq "" && $settings[7] ne "Administrator") {
                        &fatal_error("$ModifyMessage{'14'}");
                }
                $FORM{'viewnum'} = "$INFO{'id'}";
                $FORM{'thread'} = $INFO{'thread'};
                $FORM{'moda'} = "$ModifyMessage{'13'}";
        }

        open (FILE, "$datadir/$FORM{'thread'}.txt") || &fatal_error("$ModifyMessage{'1'} $FORM{'thread'}.txt");
        &lock(FILE);
        @messages = <FILE>;
        &unlock(FILE);
        close(FILE);

for ($a = 0; $a < @messages; $a++) {
        ($msub[$a], $mname[$a], $memail[$a], $mdate[$a], $musername[$a], $micon[$a], $mattach[$a], $mip[$a],  $mmessage[$a]) = split(/\|/,$messages[$a]);
}

        open (FILE, ">$datadir/$FORM{'thread'}.txt") || &fatal_error("$ModifyMessage{'1'} $FORM{'thread'}.txt");
        &lock(FILE);
        $fatalerr=0;
        for ($x = 0; $x < @messages; $x++) {
                if ($FORM{'viewnum'} eq $x) {
                        if($FORM{'moda'} eq "$ModifyMessage{'13'}") {
                                open (F, "$boardsdir/$currentboard.txt") || &fatal_error("$ModifyMessage{'1'} $currentboard.dat");
                                &lock(F);
                                @threads = <F>;
                                &unlock(F);
                                close (F);
                                open (F, ">$boardsdir/$currentboard.txt") || &fatal_error("$ModifyMessage{'1'} $currentboard.dat");
                                &lock(F);
                                for ($a = 0; $a < @threads; $a++) {
                                        if($x == (@messages-1)) { $tdate="$mdate[@messages-2]"; }
                                        else { $tdate="$mdate[$x]"; }
                                        ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$threads[$a]);
                                        $mattach =~ s/[\n\r]//g;
                                        --$mreplies;
                                        if ($mnum == $FORM{'thread'}) {
                                                print F         "$mnum\|$msub\|$mname\|$memail\|$tdate\|$mreplies\|$musername\|$micon\|$mattach\n";
                                        } else { print F "$threads[$a]"; }
                                }
                                &unlock(F);
                                close(F);
                                #####################
                                if($musername[$x] ne "Guest") {
                                        open(MEMBER, "$memberdir/$musername[$x].dat");
                                        &lock(MEMBER);
                                        @memset=<MEMBER>;
                                        &unlock(MEMBER);
                                        close(MEMBER);
                                        $memset[6] =~ s/[\n\r]//g;
                                        --$memset[6];
                                        open(MEMBER, ">$memberdir/$musername[$x].dat");
                                        &lock(MEMBER);
                                        print MEMBER "$memset[0]";
                                        print MEMBER "$memset[1]";
                                        print MEMBER "$memset[2]";
                                        print MEMBER "$memset[3]";
                                        print MEMBER "$memset[4]";
                                        print MEMBER "$memset[5]";
                                        print MEMBER "$memset[6]\n";
                                        print MEMBER "$memset[7]";
                                        print MEMBER "$memset[8]";
                                        print MEMBER "$memset[9]";
                                        print MEMBER "$memset[10]";
                                        print MEMBER "$memset[11]";
                                        print MEMBER "$memset[12]";
                                        print MEMBER "$memset[13]";
                                        print MEMBER "$memset[14]";
                                        print MEMBER "$memset[15]";
                                        &unlock(MEMBER);
                                        close(MEMBER);
                                }
                                #####################
                        } else {
                                $name = $FORM{'name'};
                                $email = $FORM{'email'};
                                $subject = $FORM{'subject'};
                                $message = $FORM{'message'};
                                $icon = $FORM{'icon'};
                                $ns = $FORM{'ns'};

                                $name =~ s/\&/\&amp;/g;
                                $email =~ s/\&/\&amp;/g;
                                $subject =~ s/\&/\&amp;/g;
                                $message =~ s/\&/\&amp;/g;
                                $name =~ s/"/\&quot;/g;
                                $email =~ s/"/\&quot;/g;
                                $subject =~ s/"/\&quot;/g;
                                $message =~ s/"/\&quot;/g;
                                $name =~ s/  / \&nbsp;/g;
                                $email =~ s/  / \&nbsp;/g;
                                $subject =~ s/  / \&nbsp;/g;
                                $message =~ s/  / \&nbsp;/g;
                                $name =~ s/</&lt;/g;
                                $name =~ s/>/&gt;/g;
                                $name =~ s/\|/\&#124;/g;
                                $email =~ s/</&lt;/g;
                                $email =~ s/>/&gt;/g;
                                $email =~ s/\|/\&#124;/g;
                                $subject =~ s/</&lt;/g;
                                $subject =~ s/>/&gt;/g;
                                $subject =~ s/\|/\&#124;/g;
                                $message =~ s/</&lt;/g;
                                $message =~ s/>/&gt;/g;
                                $message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
                                $message =~ s/\cM//g;
                                $message =~ s/\n/<br>/g;
                                $message =~ s/\|/\&#124;/g;

                                if($FORM{'viewnum'}==0) {
                                        open (F, "$boardsdir/$currentboard.txt") || &fatal_error("$ModifyMessage{'1'} $currentboard.dat");
                                        &lock(F);
                                        @threads = <F>;
                                        &unlock(F);
                                        close (F);
                                        open (F, ">$boardsdir/$currentboard.txt") || &fatal_error("$ModifyMessage{'1'} $currentboard.dat");
                                        &lock(F);
                                        for ($a = 0; $a < @threads; $a++) {
                                                ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$threads[$a]);
                                                $mattach =~ s/[\n\r]//g;
                                                if ($mnum eq "$FORM{'thread'}") {
                                                        print F         "$mnum\|$subject\|$mname\|$memail\|$mdate\|$mreplies\|$musername\|$icon\|$mattach\n";
                                                } else { print F "$threads[$a]"; }
                                        }
                                        &unlock(F);
                                        close(F);
                                }

                                if($settings[7] ne "$Administrator") {
                                print FILE "$subject\|$mname[$x]\|$memail[$x]\|$date\|$musername[$x]\|$icon\|0\|$ENV{REMOTE_ADDR}\|$message [br][b][size=$Fontsize1]($ModifyMessage{'15'} $date $ModifyMessage{'16'} $username $ModifyMessage{'17'})[/size][/b]\|$ns\n";
                                } else 
                                {
                                print FILE "$subject\|$mname[$x]\|$memail[$x]\|$date\|$musername[$x]\|$icon\|0\|$ENV{REMOTE_ADDR}\|$message |$ns\n";
                                }
                                $dpthread = $FORM{'thread'};
                                open(TN, "$boardsdir/$currentboard.txt");
                                &lock(TN);
                                @dpmsgs = <TN>;
                                &unlock(TN);
                                close(TN);
                                $dpmsgsc = 0;

                                foreach $dpentry (@dpmsgs) {
                                        ($dpthreadb, $dpsub, $dprn, $dpem, $trash, $dprc, $dpun, $dpic, $dpuk) = split(/\|/, $dpentry);
                                        if ($dpthreadb eq $dpthread) {
                                                $dpmsgs[$dpmsgsc] = "$dpthreadb|$dpsub|$dprn|$dpem|$date|$dprc|$dpun|$dpic|$dpuk";
                                                open(TN, ">$boardsdir/$currentboard.txt");
                                                &lock(TN);
                                                print TN @dpmsgs;
                                                &unlock(TN);
                                                close(TN);
                                        }
                                        $dpmsgsc++;
                                }
                        }
                }
                else {
                        print FILE $messages[$x];
                }
#                if($FORM{'viewnum'} eq "$mnum[$x]" && $mfollow[$x+1] > $mfollow[$x] && $FORM{'moda'} eq "Delete") {
# $fatalerr=1; }
        }
        &unlock (FILE);
        close (FILE);
        if($fatalerr == 1) { &fatal_error("$ModifyMessage{'18'}"); }

        print "Location: $cgi\&action=display\&num=$FORM{'thread'}\n\n";
        exit;
}

1;